module alu1(M,C1,s,a,b,f);
input M, C1;
input [3:0]s;
input [15:0]a;
input [15:0]b;
output [15:0]f;
reg [15:0]t;

always@(M or C1 or s or a or b)
	begin
	if(M) //logical
		case(s)
			4'b0000: t = ~a;
			4'b0001: t = ~(a | b);
			4'b0010: t = ~a & b;
			4'b0011: t = 0;
			4'b0100: t = ~(a & b);
			4'b0101: t = ~b;
			4'b0110: t = a ^ b;
			4'b0111: t = a & (~b);
			4'b1000: t = ~a | b;
			4'b1001: t = ~(a ^ b);
			4'b1010: t = b;
			4'b1011: t = a & b;
			4'b1100: t = 1;
			4'b1101: t = a | ~b;
			4'b1110: t = a | b;
			4'b1111: t = a;
		endcase
	else // arithmetic
	if(!C1) // carry enabled
		case(s)
			4'b0000: t=a +1;
			4'b0001: t=a|b +1;
			4'b0010: t=a|(~b) +1;
			4'b0011: t=0;
			4'b0100: t=a+(a&~b) +1;
			4'b0101: t=(a|b)+(a&~b) +1;
			4'b0110: t=a-b;
			4'b0111: t=a+(a&b);
			4'b1000: t=a&~b +1;
			4'b1001: t=a+b +1;
			4'b1010: t=(a|~b)+a&b +1;
			4'b1011: t=(a&b);
			4'b1100: t=a+a +1;
			4'b1101: t=(a|b)+a +1;
			4'b1110: t=(a|~b)+a +1;
			4'b1111: t=a;
		endcase
	else // carry disabled
		case(s)
			4'b0000: t=a;
			4'b0001: t=a|b;
			4'b0010: t=a|~b;
			4'b0011: t=-1;
			4'b0100: t=a^(a&~b);
			4'b0101: t=(a|b)^(a&~b);
			4'b0110: t=a^(~b)^(-1);
			4'b0111: t=(a&~b)^(-1);
			4'b1000: t=a^(a&b);
			4'b1001: t=a^b;
			4'b1010: t=(a|~b)^(a&b);
			4'b1011: t=(a&b)^(-1);
			4'b1100: t=0;//a^a
			4'b1101: t=(a|b)^a;
			4'b1110: t=(a|~b)^a;
			4'b1111: t=a^(-1);
		endcase
	end

assign f = t;
endmodule
